
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 07/JAN/2007   Copyright 2007-2008 Scott D. Yelich SOME RIGHTS RESERVED
  ,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.-*~'`^`'~*-,._.,-*~'`^`'~*-,


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Mon Jan  7 10:49:06 EST 2008, v0.01 sdy

*/

/*
    This is MailSend.h -- part of MailSend:

    See accompanying MailSend.cpp for implementation details.
*/

#ifndef MAILSEND_H
#define MAILSEND_H

//  C++

#include <iostream>
#include <sstream>
#include <fstream>

//  LOCAL

#include "Socket.h"
#include "Utilities.h"

//  PACKAGE

#include "Mail.h"


class MailSend
{

  public:

  MailSend();
  ~MailSend();

  void send();
  void send(std::string const & domain, std::string const & from, std::string const & to, std::string const & subject, std::string const & body);

  std::string server(std::string const & server_name="");
  std::string domain(std::string const & domain_name="");

  enum Errors {None, Init, Helo, MailFrom, RcptTo, Data, Dot, GetBytes};

  private:

  Socket socket;
  Utilities utilities;

  Mail mail;

  int local_port;
  int smtp_response_code;
  std::string smtp_name;
  std::string helo_name;
  std::string smtp_response;
  std::string smtp_response_string;
  std::ostringstream oss;

  void create_socket();

  void parse_smtp_response(std::string const & s);

  std::string get_line();
  int send_line(std::string&);
  int read_bytes(int);

  void get_initial();
  void do_helo();
  void do_mail_from();
  void do_rcpt_to();
  void do_data();

};

#endif
