
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.02 08/JAN/2008   Copyright 2007-2008 Scott D. Yelich SOME RIGHTS RESERVED
  ,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.,-*~'`^`'~*-,._.-*~'`^`'~*-,._.,-*~'`^`'~*-,


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Wed Jun  6 11:19:52 EDT 2007, v0.01 sdy
  Tue Jan  8 22:53:34 EST 2008, v0.02 sdy

*/

/*
    This is Socket.h -- part of Socket:

    See accompanying Socket.cpp for implementation details.
*/

#ifndef SOCKET_H
#define SOCKET_H

// C

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <errno.h>

#include "sys/time.h"


//  C++

#include <string>

//  PACKAGE

#include "TypedException.h"


class Socket
{

  public:

  //  some public values ...

  static const int MAX_RECV = 2500;
  //    static const int MAX_CONNECT_QUEUE = 128;
  static const int MAX_CONNECT_QUEUE = 1023;

  enum Errors { Create, Bind, Opt, Listen, Accept, Connect, Receive, Select };

  Socket();
  ~Socket();

  void create();
  void bind(const int port);

  void connect(const std::string host, const int port);
  void disconnect();

  int send(const std::string s="" );
  bool recv_peek(int timeout_seconds = 0);
  int recv();
  bool writeable();

  void listen(const int);
  void reuseport(); //  pass boolean?
  int accept();

  void set_non_blocking(const bool);

  void setfd(const int);
  int getfd();

  std::string & input();
  void clearinput(int len = -1);

  //  bool is_valid() const { return socket_handle != 0; }


  private:

  int socket_handle;

  sockaddr_in socket_addr;
  sockaddr_in remote_addr;

  std::string ibuf;
  std::string obuf;
    
};

#endif
